// dllimport.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include "windows.h"
#include <stdlib.h>


typedef int   (*IS_WINNT)(void);
typedef int   (*STARTDAUNY)(const char*);
typedef int   (*STOPDAUNY)(const char*);
typedef int   (*STARTDAUNYSERVICE)(void);
typedef int   (*STOPDAUNYSERVICE)(void);
typedef char* (*ENCRYPTPASSWORT)(const char*,const char*);
typedef char* (*DLLVERSION)();

typedef int   (*SHUTDOWNSYSTEM)();

typedef int   (*LOADTRAYICON)(const char*,int,char*);
typedef int   (*SHOWTRAYICON)(int);
typedef int   (*REMOVETRAYICON)(void);
typedef int   (*LOADTRAYICONS)(char*,int,int,int);
typedef int   (*SETTRAYICONTOOLTIP)(int,char*);

typedef int   (*GOONLINE)(void);
typedef int   (*GOOFFLINE)(void);
typedef int   (*ISONLINE)(void);

typedef int   (*INSTALLMOUSECALLBACK)(HINSTANCE);

#define TRAYICON_LBUTTONDBLCLK  1
#define TRAYICON_LBUTTONDOWN    2
#define TRAYICON_LBUTTONUP      3
#define TRAYICON_RBUTTONDOWN    4
#define TRAYICON_RBUTTONUP      5
#define TRAYICON_MOUSEFIRST     6

BOOL bPrintCallbackMessage;

BOOL bLBUTTONDBLCLK,bLBUTTONDOWN,bLBUTTONUP,bRBUTTONDOWN,bRBUTTONUP,bMOUSEFIRST;


extern "C" __declspec(dllexport) int MouseCallback(int nType){

	switch (nType) {
		case TRAYICON_LBUTTONDBLCLK:
			if(bPrintCallbackMessage && !bLBUTTONDBLCLK)
				printf("Mouse Callback - left button double click\n");
			bLBUTTONDBLCLK=TRUE;
			break;
		case TRAYICON_LBUTTONDOWN:
			if(bPrintCallbackMessage && !bLBUTTONDOWN)
				printf("Mouse Callback - left button down\n");
			bLBUTTONDOWN=TRUE;
			break;
		case TRAYICON_LBUTTONUP:
			if(bPrintCallbackMessage && !bLBUTTONUP)
				printf("Mouse Callback - left button up\n");
			bLBUTTONUP=TRUE;
			break;
		case TRAYICON_RBUTTONDOWN:
			if(bPrintCallbackMessage && !bRBUTTONDOWN)
				printf("Mouse Callback - right button down\n");
			bRBUTTONDOWN=TRUE;
			break;
		case TRAYICON_RBUTTONUP:
			if(bPrintCallbackMessage && !bRBUTTONUP)
				printf("Mouse Callback - right button up\n");
			bRBUTTONUP=TRUE;
			break;
		case 	TRAYICON_MOUSEFIRST:
			if(bPrintCallbackMessage && !bMOUSEFIRST)
				printf("Mouse Callback - first over icon\n");
			bMOUSEFIRST=TRUE;
			break;
		default:
			if(bPrintCallbackMessage)
				printf("Mouse Callback - unknown mouse callback\n");
			break;
	}

	return(nType);
}

void ClearCallbackBools(){
	bLBUTTONDBLCLK=FALSE;
	bLBUTTONDOWN=FALSE;
	bLBUTTONUP=FALSE;
	bRBUTTONDOWN=FALSE;
	bRBUTTONUP=FALSE;
	bMOUSEFIRST=FALSE;
}

int main(int argc, char* argv[])
{

	char szBuffer[MAX_PATH];
	char szBuffer2[MAX_PATH];
	char szBuffer3[MAX_PATH];

	HINSTANCE hLib; 
	
	IS_WINNT           Is_Winnt; 
	STARTDAUNY         StartDauny;
	STOPDAUNY          StopDauny;
	STARTDAUNYSERVICE  StartDaunyService;
	STOPDAUNYSERVICE   StopDaunyService;
	ENCRYPTPASSWORT    EncryptPasswort;
	DLLVERSION         DllVersion;

	LOADTRAYICON       LoadTrayIcon;
	SHOWTRAYICON       ShowTrayIcon;
	LOADTRAYICONS      LoadTrayIcons;
	SETTRAYICONTOOLTIP SetTrayIconToolTip;
	REMOVETRAYICON     RemoveTrayIcon;
	
	SHUTDOWNSYSTEM     ShutdownSystem;

	GOONLINE					 GoOnline;
	GOOFFLINE					 GoOffline;
	ISONLINE					 IsOnline;


	int nResult;
	char* VersionString;
	char ch;

	bPrintCallbackMessage=FALSE;
	printf("dllimport example for 'daunytools.dll' (version 1.31)\n\n");

//	hLib = LoadLibrary("F:\\develop\\dauny\\daunytools.dll\\Debug\\daunytools.dll"); //UNZIP32STATIC.DLL
	if (argc>1)
		hLib = LoadLibrary(argv[1]);
	else
		hLib = LoadLibrary("daunytools.dll");
	if (hLib != NULL) {

		printf("check function 'DllVersion' ...");
		DllVersion = (DLLVERSION) GetProcAddress (hLib, "DllVersion");
		if (DllVersion != NULL) {
			VersionString=(*DllVersion) (); 
			if (VersionString)
				printf("OK --> daunytoools.dll Version %s found\n",VersionString);
			else
				printf("OK --> daunytoools.dll Version not found\n");
		}
		else
			printf("FAILED: can't call 'LoadTrayIcon' from \"daunytools.dll\"\n");
		printf("\n");


		///////////////// LoadTrayIcon /////////////////
		printf("check function 'LoadTrayIcon' ...");
		LoadTrayIcon = (LOADTRAYICON) GetProcAddress (hLib, "LoadTrayIcon");
		if (LoadTrayIcon != NULL) {
			//nResult=(*LoadTrayIcon) ("F:\\develop\\dauny\\daunytools.dll\\dauny1.ico",0,"Icon 1"); 
			nResult=(*LoadTrayIcon) ("dauny1.ico",0,"Icon 1"); 
			if (nResult==1)
				printf("\nOK --> TrayIcon 1 loaded\n");
			else
				printf("\nOK --> TrayIcon 1 not loaded, error %d\n",nResult);
			//nResult=(*LoadTrayIcon) ("F:\\develop\\dauny\\daunytools.dll\\dauny2.ico",1,"Icon 2"); 
			nResult=(*LoadTrayIcon) ("dauny2.ico",1,"Icon 2"); 
			if (nResult==1)
				printf("OK --> TrayIcon 2 loaded\n");
			else
				printf("OK --> TrayIcon 2 not loaded, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'LoadTrayIcon' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(1000);

		///////////////// ShowTrayIcon /////////////////
		printf("check function 'ShowTrayIcon' ...");
		ShowTrayIcon = (SHOWTRAYICON) GetProcAddress (hLib, "ShowTrayIcon");
		if (ShowTrayIcon != NULL) {
			nResult=(*ShowTrayIcon) (0); 
			if (nResult)
				printf("\nOK --> TrayIcon 1 showed\n");
			else
				printf("\nOK --> TrayIcon 1 not showed, error %d\n",nResult);
			Sleep(4000);
			nResult=(*ShowTrayIcon) (1); 
			if (nResult)
				printf("OK --> TrayIcon 2 showed\n");
			else
				printf("OK --> TrayIcon 2 not showed, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'ShowTrayIcon' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(3000);

		
		printf("check callback function 'MouseCallback' (please click on tray icon ...\n");
		ClearCallbackBools();
		bPrintCallbackMessage=TRUE;

		for (int delaycount=0;delaycount<10;delaycount++){
			Sleep(1000);
			if (bLBUTTONDBLCLK && bLBUTTONDOWN && bLBUTTONUP && bRBUTTONDOWN && bRBUTTONUP && bMOUSEFIRST){

				printf("OK --> All Function passed\n\n");
				break;
			}
		}
		bPrintCallbackMessage=FALSE;


	//	LoadTrayIcons (char* DllORIconName,int nFileIndex,int nIndex,int nIconCount)
		///////////////// LoadTrayIcon /////////////////
		printf("check function 'LoadTrayIcons' ...");
		LoadTrayIcons = (LOADTRAYICONS) GetProcAddress (hLib, "LoadTrayIcons");
		if (LoadTrayIcons != NULL) {
			//char* DllORIconName,int nFileIndex,int nIndex,int nIconCount
			nResult=(*LoadTrayIcons) ("icondll.dll",0,2,2); 
			if (nResult==2)
				printf("\nOK --> TrayIcons loaded\n");
			else
				printf("\nOK --> TrayIcons not loaded, error %d\n",nResult);

		}
		else
			printf("FAILED: can't call 'LoadTrayIcons' from \"daunytools.dll\"\n");
		printf("\n");


		///////////////// SetTrayIconToolTip /////////////////
		printf("check function 'SetTrayIconToolTip' ...");
		SetTrayIconToolTip = (SETTRAYICONTOOLTIP) GetProcAddress (hLib, "SetTrayIconToolTip");
		if (SetTrayIconToolTip != NULL) {
			nResult=(*SetTrayIconToolTip) (2,"Icon 3 - Dauny"); 
			if (nResult)
				printf("\nOK --> TrayIcon 3 ToolTip set\n");
			else
				printf("\nOK --> TrayIcon 3 not set, error %d\n",nResult);
			nResult=(*SetTrayIconToolTip) (3,"Icon 4 - Dauny"); 
			if (nResult)
				printf("OK --> TrayIcon 4 ToolTip set\n");
			else
				printf("OK --> TrayIcon 4 not set, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'SetTrayIconToolTip' from \"daunytools.dll\"\n");
		printf("\n");	


		///////////////// ShowTrayIcon /////////////////
		if (ShowTrayIcon != NULL) {
			nResult=(*ShowTrayIcon) (2); 
			if (nResult)
				printf("\nOK --> TrayIcon 3 showed\n");
			else
				printf("\nOK --> TrayIcon 3 not showed, error %d\n",nResult);
			Sleep(4000);
			nResult=(*ShowTrayIcon) (3); 
			if (nResult)
				printf("OK --> TrayIcon 4 showed\n");
			else
				printf("OK --> TrayIcon 5 not showed, error %d\n",nResult);
		}
		printf("\n");

		Sleep(3000);


		///////////////// RemoveTrayIcon /////////////////
		printf("check function 'RemoveTrayIcon' ...");
		RemoveTrayIcon = (REMOVETRAYICON) GetProcAddress (hLib, "RemoveTrayIcon");
		if (RemoveTrayIcon != NULL) {
			nResult=(*RemoveTrayIcon) (); 
			if (nResult)
				printf("OK --> TrayIcon removed\n");
			else
				printf("OK --> TrayIcon not removed, error only %d loaded\n",nResult);
		}
		else
			printf("FAILED: can't call 'RemoveTrayIcon' from \"daunytools.dll\"\n");
		printf("\n");	


		///////////////// IsWindowsNT /////////////////
		printf("check function 'IsWindowsNT' ...");
		Is_Winnt = (IS_WINNT) GetProcAddress (hLib, "IsWindowsNT");
		if (Is_Winnt != NULL) {
			nResult=(*Is_Winnt) (); 
			if (nResult)
				printf("OK --> WintNT found\n");
			else
				printf("OK --> no WintNT found\n");
		}
		else
			printf("FAILED: can't call 'IsWindowsNT' from \"daunytools.dll\"\n");
		printf("\n");

		///////////////// EncryptPasswort /////////////////
		printf("check function 'EncryptPasswort' ...");
		strcpy(szBuffer2,"PASS1");
		strcpy(szBuffer3,"A7D46E59C16DC72245F1F1C42F235CED0D53D68F");
		char* EncryptedPassword;
		char* Loginname=szBuffer2;
		char* ConnectionKey=szBuffer3;
		EncryptPasswort = (ENCRYPTPASSWORT) GetProcAddress (hLib, "EncryptPasswort");
		if (EncryptPasswort != NULL) {
			EncryptedPassword=(*EncryptPasswort)(Loginname,ConnectionKey); 

			printf("OK -->\n Encrypted password: %s\n",EncryptedPassword);
		}
		else
			printf("FAILED: can't call 'EncryptPasswort' from \"daunytools.dll\"\n");
		printf("\n");


		///////////////// StartDauny /////////////////
		printf("check function 'StartDauny' ...");
		strcpy(szBuffer,"d:\\programme\\dauny\\dauny.exe");
		StartDauny = (STARTDAUNY) GetProcAddress (hLib, "StartDauny");
		if (StartDauny != NULL) {
			nResult=(*StartDauny) ((const char*)szBuffer); 
			if (nResult==0)
				printf("OK --> Dauny started\n");
			else
				printf("OK --> Dauny not started, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'StartDauny' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(1000);

		///////////////// StopDauny /////////////////
		printf("check function 'StopDauny' ...");
		strcpy(szBuffer,"d:\\programme\\dauny\\");
		StopDauny = (STOPDAUNY) GetProcAddress (hLib, "StopDauny");
		if (StopDauny != NULL) {
			nResult=(*StopDauny) ((const char*)szBuffer); 
			if (nResult==0)
				printf("OK --> Dauny stopped\n");
			else
				printf("OK --> Dauny not stopped, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'StartDauny' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(2000);

		///////////////// StartDaunyService /////////////////
		printf("check function 'StartDaunyService' ...");
		StartDaunyService = (STARTDAUNYSERVICE) GetProcAddress (hLib, "StartDaunyService");
		if (StartDaunyService != NULL) {
			nResult=(*StartDaunyService)(); 
			if (nResult==0)
				printf("OK --> Dauny service started\n");
			else
				printf("OK --> Dauny service not started, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'StartDaunyService' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(1000);

		///////////////// StopDaunyService /////////////////
		printf("check function 'StopDaunyService' ...");
		StopDaunyService = (STOPDAUNYSERVICE) GetProcAddress (hLib, "StopDaunyService");
		if (StopDaunyService != NULL) {
			nResult=(*StopDaunyService)(); 
			if (nResult==0)
				printf("OK --> Dauny service stopped\n");
			else
				printf("OK --> Dauny service not stopped, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'StopDaunyService' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(2000);


		///////////////// IsOnline /////////////////

		printf("check function 'IsOnline' ...");
		IsOnline = (ISONLINE) GetProcAddress (hLib, "IsOnline");
		if (IsOnline != NULL) {
			nResult=(*IsOnline)(); 
			if (nResult==1 )
				printf("OK --> Online\n");
			else if (nResult==0 )
				printf("OK --> Offline\n");
			else
				printf("OK --> uknown Online status, error %d\n",nResult);
		}
		else
			printf("FAILED: can't call 'IsOnline' from \"daunytools.dll\"\n");
		printf("\n");

		Sleep(2000);

		fflush(stdin);
		printf("Do you want to test GoOnline and GoOffline function [y/n]?");
		ch=getchar();
		if (ch=='y' ||  ch=='Y'){

			///////////////// GoOnline/GoOffline /////////////////

			if (nResult!=1){
				printf("check function 'GoOnline' (works only if allowed)...");
				GoOnline = (GOONLINE) GetProcAddress (hLib, "GoOnline");
				if (GoOnline != NULL) {
					nResult=(*GoOnline)(); 
					if (nResult==1 )
						printf("OK --> Online OK\n");
					else if (nResult==0 )
						printf("OK --> Online not OK\n");
					else
						printf("OK --> error in function, error %d\n",nResult);
				}
				else
					printf("FAILED: can't call 'GoOnline' from \"daunytools.dll\"\n");
				printf("\n");
			}
			else {
				printf("check function 'GoOffline' (works only if allowed) ...");
				GoOffline = (GOOFFLINE) GetProcAddress (hLib, "GoOffline");
				if (GoOffline != NULL) {
					nResult=(*GoOffline)(); 
					if (nResult==1 )
						printf("OK --> Offline OK\n");
					else if(nResult==0 )
						printf("OK --> Offline not OK\n");
					else
						printf("OK --> error in function, error %d\n",nResult);
				}
				else
					printf("FAILED: can't call 'GoOffline' from \"daunytools.dll\"\n");
				printf("\n");
			}

			Sleep(5000);

			if (IsOnline != NULL) {
				nResult=(*IsOnline)(); 
				if (nResult==1 )
					printf("OK --> Online\n");
				else if(nResult==0 )
					printf("OK --> Offline\n");
				else
					printf("OK --> uknown Online status, error %d\n",nResult);
			}
			else
				printf("FAILED: can't call 'IsOnline' from \"daunytools.dll\"\n");


			if (nResult!=1){
				if (GoOnline != NULL) {
					nResult=(*GoOnline)(); 
					if (nResult==1 )
						printf("OK --> Online OK\n");
					else if(nResult==0 )
						printf("OK --> Online not OK\n");
					else
						printf("OK --> error in function, error %d\n",nResult);
				}
				else
					printf("FAILED: can't call 'GoOnline' from \"daunytools.dll\"\n");
				printf("\n");
			}
			else {
				if (GoOffline != NULL) {
					nResult=(*GoOffline)(); 
					if (nResult==1 )
						printf("OK --> Offline OK\n");
					else if(nResult==0 )
						printf("OK --> Offline not OK\n");
					else
						printf("OK --> error in function, error %d\n",nResult);
				}
				else
					printf("FAILED: can't call 'GoOffline' from \"daunytools.dll\"\n");
				printf("\n");
			}
		}
		///////////////// ShutdownSystem /////////////////

		fflush(stdin);
		printf("Do you want to test ShutdownSystem function [y/n]?");
		ch=getchar();
		if (ch=='y' ||  ch=='Y'){

			printf("check function 'ShutdownSystem' ...");
			ShutdownSystem = (SHUTDOWNSYSTEM) GetProcAddress (hLib, "ShutdownSystem");
			if (ShutdownSystem != NULL) {
				nResult=(*ShutdownSystem)(); 
				if (nResult)
					printf("OK --> Shutdown started\n");
				else
					printf("OK --> Shutdown not started\n");
			}
			else
				printf("FAILED: can't call 'StopDaunyService' from \"daunytools.dll\"\n");
			printf("\n");

		}

		FreeLibrary(hLib);  
		nResult=0;
	}
	else{
		printf("can't load \"daunytools.dll\"\n");
		nResult=1;
	}

	printf("sleep 5sec\n");
	Sleep(5000);
	return(nResult);
}

